/*
 * set-04.cc    Standard Library, std::set, exercise 4.
 */
#include <iostream>
#include <iterator>
#include <set>
using namespace std;

template<typename T> 
ostream& operator<<(ostream& os, const set<T>& s)
{
   copy(begin(s), end(s), ostream_iterator<T>(cout, " "));
   return os;
}

template<typename T>
set<T> operator-(const set<T>& lhs, const set<T>& rhs)
{
   set<T> result{ lhs };
   for (const auto& e : rhs)
      result.erase(e);
   return result;
}

int main()
{
   set<string> s1{ "foo", "bar", "gazonk", "foobar" };
   set<string> s2{ "foo", "fum", "godzilla", "bar" };

   cout << '\n';
   cout << "s1: " << s1 << '\n';
   cout << "s2: " << s2 << "\n\n";

   cout << "s1 - s2: " << s1 - s2 << '\n';

   return 0;
}
